> ## Documentation Index
> Fetch the complete documentation index at: https://statsig-preview.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Dynamic Config Rule By Name



## OpenAPI

````yaml api-reference/statsig_openapi.json patch /console/v1/dynamic_configs/{id}/rule/name/{ruleName}
openapi: 3.0.0
info:
  title: Console API
  description: >-
    The "Console API" is the CRUD API for performing the actions offered on
    console.statsig.com without needing to go through the web UI.

    If you have any feature requests, drop on in to our [slack
    channel](https://www.statsig.com/slack) and let us know.

    <br /><br />

    <b>Authorization</b>

    <br />

    All requests must include the **STATSIG-API-KEY** field in the header. The
    value should be a **Console API Key** which can be created in the Project
    Settings on
    [console.statsig.com/api_keys](https://console.statsig.com/api_keys)

    <br /><br />

    <b>Rate Limiting</b>

    <br />

    Requests to the Console API are limited to <code>~ 100reqs / 10secs and ~
    900reqs / 15 mins</code>.

    <br /><br />

    <b>Keyboard Search</b>

    <br />

    Use <code>Ctrl/Cmd + K</code> to search for specific endpoints.
  version: 20240601.0.0
  contact: {}
servers:
  - url: https://statsigapi.net
security: []
tags: []
paths:
  /console/v1/dynamic_configs/{id}/rule/name/{ruleName}:
    patch:
      tags:
        - Dynamic Configs
      summary: Update Dynamic Config Rule By Name
      parameters:
        - name: id
          required: true
          in: path
          description: Dynamic Config ID
          schema:
            type: string
        - name: ruleName
          required: true
          in: path
          description: Rule Name
          schema:
            type: string
        - name: x-respect-review-settings
          in: header
          description: Optional header to respect review settings for mutation endpoints.
          required: false
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/RuleUpdateDto'
      responses:
        '200':
          description: Update Dynamic Config Rule Response
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/SingleDataResponse'
                  - properties:
                      data:
                        $ref: '#/components/schemas/DynamicConfigDto'
                example:
                  message: Dynamic Config rules updated successfully.
                  data:
                    id: dc2
                    name: dc2
                    description: ''
                    idType: userID
                    lastModifierID: 65pqqzT46Kl7lHnd2JCmgH
                    lastModifiedTime: 1721248745926
                    lastModifierName: CONSOLE API
                    lastModifierEmail: null
                    creatorID: 3exemrfZ5pwOk6qyDH0dhP
                    createdTime: 1721247911588
                    creatorName: Jathu Theivikaran
                    creatorEmail: jathurshan@statsig.com
                    targetApps: []
                    holdoutIDs: []
                    tags: []
                    team: null
                    isEnabled: true
                    rules:
                      - id: 1HnUxxykNK2zl8AqW0HAl5
                        baseID: 1HnUxxykNK2zl8AqW0HAl5
                        name: CA
                        passPercentage: 100
                        conditions: []
                        returnValue: true
                        returnValueJson5: 'true'
                        environments: null
                      - id: 2IIQAN6wbUyHJiLbrcBuvx:80.00:1
                        baseID: 2IIQAN6wbUyHJiLbrcBuvx
                        name: Other
                        passPercentage: 80
                        conditions: []
                        returnValue: true
                        returnValueJson5: 'true'
                        environments: null
                    defaultValue: {}
                    defaultValueJson5: '{}'
              example:
                message: Dynamic Config rules updated successfully.
                data:
                  id: dc2
                  name: dc2
                  description: ''
                  idType: userID
                  lastModifierID: 65pqqzT46Kl7lHnd2JCmgH
                  lastModifiedTime: 1721248745926
                  lastModifierName: CONSOLE API
                  lastModifierEmail: null
                  creatorID: 3exemrfZ5pwOk6qyDH0dhP
                  createdTime: 1721247911588
                  creatorName: Jathu Theivikaran
                  creatorEmail: jathurshan@statsig.com
                  targetApps: []
                  holdoutIDs: []
                  tags: []
                  team: null
                  isEnabled: true
                  rules:
                    - id: 1HnUxxykNK2zl8AqW0HAl5
                      baseID: 1HnUxxykNK2zl8AqW0HAl5
                      name: CA
                      passPercentage: 100
                      conditions: []
                      returnValue: true
                      returnValueJson5: 'true'
                      environments: null
                    - id: 2IIQAN6wbUyHJiLbrcBuvx:80.00:1
                      baseID: 2IIQAN6wbUyHJiLbrcBuvx
                      name: Other
                      passPercentage: 80
                      conditions: []
                      returnValue: true
                      returnValueJson5: 'true'
                      environments: null
                  defaultValue: {}
                  defaultValueJson5: '{}'
      security:
        - STATSIG-API-KEY: []
components:
  schemas:
    RuleUpdateDto:
      type: object
      properties:
        name:
          type: string
          description: The name of this rule.
        passPercentage:
          type: number
          minimum: 0
          maximum: 100
          multipleOf: 0.01
          description: >-
            Of the users that meet the conditions of this rule, what percent
            should return true.
        conditions:
          type: array
          items:
            type: object
            properties:
              targetValue:
                oneOf:
                  - type: array
                    items:
                      type: string
                  - type: array
                    items:
                      type: number
                  - type: string
                  - type: number
                nullable: true
              operator:
                type: string
              field:
                type: string
                nullable: true
              customID:
                type: string
                nullable: true
              type:
                type: string
                enum:
                  - app_version
                  - browser_name
                  - browser_version
                  - country
                  - custom_field
                  - email
                  - environment_tier
                  - fails_gate
                  - fails_segment
                  - ip_address
                  - locale
                  - os_name
                  - os_version
                  - passes_gate
                  - passes_segment
                  - public
                  - time
                  - unit_id
                  - user_id
                  - url
                  - javascript
                  - device_model
                  - target_app
            required:
              - type
          description: An array of Condition objects.
        environments:
          type: array
          items:
            type: string
          nullable: true
          description: The environments this rule is enabled for.
        id:
          type: string
          description: The Statsig ID of this rule.
        baseID:
          type: string
          description: >-
            The base ID of this rule, i.e. without any added metadata. Will
            remain the exact same throughout
        returnValue:
          type: object
          additionalProperties: {}
          description: The return value of the rule.
      example:
        name: All Conditions
        id: 38ttpCpzrQFTMKcqFKk02l:10.00:1
        baseID: 38ttpCpzrQFTMKcqFKk02l
        passPercentage: 10
        conditions:
          - type: user_id
            targetValue:
              - 35sClJFs8l0y5uRQhDwUDo
            operator: any
        environments:
          - staging
    SingleDataResponse:
      type: object
      properties:
        message:
          type: string
          description: A simple string explaining the result of the operation.
        data:
          type: object
          description: A single result.
      required:
        - message
        - data
    DynamicConfigDto:
      type: object
      properties:
        id:
          type: string
          description: ID
        name:
          type: string
          description: Optional name for the configuration.
        idType:
          type: string
          description: The type of ID which the dynamic config is based on.
          example: userID
        description:
          type: string
          maxLength: 1000
          description: A brief summary of what the dynamic config is being used for
          example: helpful summary of what this dynamic config does
        lastModifierID:
          type: string
          nullable: true
          description: ID of the last modifier.
        lastModifiedTime:
          type: number
          nullable: true
          description: Time of the last modification.
        lastModifierEmail:
          type: string
          nullable: true
          description: Email of the last modifier.
        lastModifierName:
          type: string
          nullable: true
          description: Name of the last modifier.
        creatorID:
          type: string
          nullable: true
        createdTime:
          type: number
          description: Timestamp when the entity was created.
        creatorName:
          type: string
          nullable: true
          description: Name of the creator.
        creatorEmail:
          type: string
          nullable: true
        tags:
          type: array
          items:
            type: string
          description: The list of tag names attached to the dynamic config
          example:
            - a tag
        targetApps:
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        holdoutIDs:
          type: array
          items:
            type: string
          description: Holdouts applied to this configuration.
        team:
          type: string
          nullable: true
          description: The team name associated with the dynamic config, Enterprise only.
        teamID:
          type: string
          nullable: true
          description: The team ID associated with the dynamic config, Enterprise only.
        version:
          type: number
          description: Version number
        isEnabled:
          type: boolean
          description: Is the dynamic config enabled
          default: true
        rules:
          type: array
          items:
            type: object
            properties:
              name:
                type: string
                description: The name of this rule.
              passPercentage:
                type: number
                minimum: 0
                maximum: 100
                multipleOf: 0.01
                description: >-
                  Of the users that meet the conditions of this rule, what
                  percent should return true.
              conditions:
                type: array
                items:
                  type: object
                  properties:
                    targetValue:
                      oneOf:
                        - type: array
                          items:
                            type: string
                        - type: array
                          items:
                            type: number
                        - type: string
                        - type: number
                      nullable: true
                    operator:
                      type: string
                    field:
                      type: string
                      nullable: true
                    customID:
                      type: string
                      nullable: true
                    type:
                      type: string
                      enum:
                        - app_version
                        - browser_name
                        - browser_version
                        - country
                        - custom_field
                        - email
                        - environment_tier
                        - fails_gate
                        - fails_segment
                        - ip_address
                        - locale
                        - os_name
                        - os_version
                        - passes_gate
                        - passes_segment
                        - public
                        - time
                        - unit_id
                        - user_id
                        - url
                        - javascript
                        - device_model
                        - target_app
                  required:
                    - type
                description: An array of Condition objects.
              environments:
                type: array
                items:
                  type: string
                nullable: true
              id:
                type: string
                description: The Statsig ID of this rule.
              baseID:
                type: string
                description: >-
                  The base ID of this rule, i.e. without any added metadata.
                  Will remain the exact same throughout
              returnValue:
                type: object
                additionalProperties: {}
              returnValueJson5:
                type: string
            required:
              - name
              - passPercentage
              - conditions
          description: An array of Rule objects
        defaultValue:
          type: object
          additionalProperties: {}
          description: The fallback JSON object when no rules are triggered
        defaultValueJson5:
          type: string
          description: >-
            Can include comments. If provided with defaultValue, must parse to
            the same JSON
        owner:
          type: object
          properties:
            ownerID:
              type: string
              description: ID of the owner
              example: abc123
            ownerType:
              type: string
              description: Type of the owner (e.g., SDK_KEY or USER)
              example: USER
            ownerName:
              type: string
              description: The name of the owner. This field is optional.
              example: John Doe
            ownerEmail:
              type: string
              description: The email of the owner. This field is optional.
          description: >-
            Schema for owner data including ID, type, name. Note that if Entity
            is created by CONSOLE API, owner will be undefined.
          example:
            ownerID: user123
            ownerType: USER
            ownerName: John Doe
            ownerEmail: owner123@test.com
          nullable: true
        schema:
          type: string
          nullable: true
          description: >-
            A schema using JSON Schema Draft 2020-12 to enforce return values of
            this dynamic config's rules.
        schemaJson5:
          type: string
          nullable: true
          description: >-
            `schema` except with Json5 comments. Optional and should parse to
            same json as `schema`.
        precommitWebhook:
          type: object
          properties:
            url:
              type: string
            internalStatusUrl:
              type: string
          required:
            - url
            - internalStatusUrl
          nullable: true
      required:
        - id
        - description
        - lastModifierID
        - lastModifiedTime
        - lastModifierEmail
        - lastModifierName
        - createdTime
        - creatorName
        - isEnabled
        - rules
  securitySchemes:
    STATSIG-API-KEY:
      type: apiKey
      name: STATSIG-API-KEY
      in: header

````